/*
 *   Copyright (C) 2002-2006
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "tac_plus.h"
#include <time.h>

#ifndef FREEBSD
#define USE_ACE_AGENT_API_PROTOTYPES
#include "include/acexport.h"
#endif

/**
 * Function:	SD_Authenticate
 * Parameters:	user - user id
 * 		user_passwd - user password
 * Returns:	0 - authentication failed
 * 		1 - authentication passed
 * 		4 - cannot communicate with AceServer
 * 		5 - cannot lock user name
**/
int SD_Authenticate( string user, string user_passwd) {
	int ret = 0;
#ifndef FREEBSD
	int acmRet;
	SDI_HANDLE SdiHandle = SDI_HANDLE_NONE;

	acmRet = SD_Init(&SdiHandle);
	if (acmRet != ACM_OK)
		return (4);

	acmRet = SD_Lock(SdiHandle, (SD_CHAR*)user.c_str());
	if (acmRet != ACM_OK)
		return (5);

	acmRet = SD_Check(SdiHandle, (SD_CHAR*)user_passwd.c_str(), (SD_CHAR*)user.c_str());
	switch (acmRet) {
		case ACM_OK:
			ret = 1;
			break;
			
		case ACM_INVALID_SERVER:
			ret = 4;
			break;
			
		case ACM_ACCESS_DENIED:
		case ACM_NEXT_CODE_REQUIRED:
		case ACM_NEW_PIN_REQUIRED:
			break;

		default:
			ret = 4;
	}

	SD_Close(SdiHandle);
#endif
	return (ret);
}

